#include "asm86.h" 
#include "ti86asm.inc" 
#include ti86abs.inc
_flushallmenus  equ     49DCh   ; clear the 86's menu key stacks
_dispAHL = $4a33
_homeup         equ       4A95h       ; cursror to top left of home screen
score = TEXT_MEM+3

x		   = $C0FF   ; X location of Robot
y		   = $C101   ; Y location of Robot
gx	   = $C105   ;  x location of other robot
gy	   = $C106   ;  y location of other robot
counter	   = $C107   ; 
dead          = $C108   ; 
hlast	   = $C10B   ; 
deat 	   = $C10C   ; 
counter2	   = $C10D   ;
counter3	   = $C10E   ; 
timer5 	   = $C112   ; 

.org _asm_exec_ram   ; start of asm

;----------------------
	nop
	jp main
.dw 0000                 ;Ashell stuff
.dw title
title:
.db "Robot Wars by Matt Teiken",0
;----------------------

HighS:	.dw 0  ;This is to hold the high score while the program is running
               ;Remember that you must store the highscore into the program
               ;before exiting if you want to save it.

main:
    call BUSY_OFF
    call _flushallmenus
    call _clrLCD       ;clear screen
 ld hl,TitleScreen
 ld de,$fc00
 call DispRLE				; decode and display the picture
 call pause


    call _flushallmenus

  sbc	hl,hl	
  ld (score),hl

  ld hl, (score)
  add hl, hl			; hl=score*2



 ld a,101 
 ld (time),a
 ld a,10
 ld (x),a
 ld (y),a
 ld a,0                                 ;set starting values for variables
 ld (timer5),a
 ld a,10
 ld (gy),a
 ld a,25
 ld (gx),a
 ld a,5
 ld (counter),a
 ld (counter3),a
 ld (counter2),a

scoretext:
.db "Score:",0

Start:
 call BUSY_OFF
 call _clrLCD
 call LoadPlayer
 call LoadGopher

 ld de, 0165h
 ld hl,robot
 call DispText

 ld de, 0766h
 ld hl,wars
 call DispText

 ld de, 2065h
 ld hl,scoretxt
 call DispText

 ld de, 1065h
 ld hl,timetxt
 call DispText




MainLoop:
 ld a,(counter)
 inc a
 ld (counter),a
 cp 150 
 jr z, GetInput
 jp MainLoop 
GetInput:

 call UpdateTime
 ld a,c
 cp 160
 jp z,Exit

 ld a,5
 ld (counter),a
 ld a,(counter3)
 inc a
 ld (counter3),a
 cp 45
 jp z,reset3
 jp check2
reset3:
 ld a,5
 ld (counter3),a
check2: 
 ld a,(counter2)
 inc a
 ld (counter2),a
 cp 110
 jp z,reset2;
 jp continput
reset2:
 ld a,5
 ld (counter2),a
continput:
 ld a,$FE
 out (1),a
 nop
 nop
 in a,(1)
 bit 2,a	      
 jp z,MoveRight      
 bit 1,a	      
 jp z,MoveLeft 
 bit 3,a	      
 jp z,MoveUp      
 bit 0,a	      
 jp z,MoveDown    

 ld a,$BF
 out (1),a
 nop
 nop
 in a,(1)
 bit 6,a	       ; Check if Exit has been pressed
 jr z,Exit

 jp MainLoop
Exit:

 ld de, 1825h
 ld hl,gameover
 call DispText

 call GET_KEY
 call pause
 call _clrLCD

dispHigh:
  ld de,$0610
  ld hl,HighScr
  call DispText
  ld de,0634h
  ld hl,(HighS)
  call SdispHL
show_sc:
 ld de, 1810h
 ld hl,scoretxt
 call DispText
	ld de,1825h
 ld hl,(score)
 call SdispHL
 call GET_KEY			; flush keypress buffer

CheckHigh:
 ld de,(HighS)
 ld hl,(score)
 call scorechk
 or a
 jp nz,EndLoop
 ld (HighS),hl
	ld hl,varname-1
	rst 20h
	rst 10h
	ld a,b
	ex de,hl
	call _load_ram_ahl
	ld de,HighS-$d744
	add hl,de
	ld de,(HighS)
	ld (hl),e
	inc hl
	ld (hl),d
 ld hl,1010h
 ld (_penCol),hl
 ld hl,NHSMsg
 call _vputs
EndLoop:
 call pause
	call _homeup
	call _clrScrn
 ret
;---------= High Score =---------
; Input: de=previous high score
;	hl=current score
; Output: hl=high score
;	z=1 (a=0) if new high score, z=0 (a=1) if not
; Registers destroyed: af, de, hl
scorechk:
	push	hl
	xor	a
	sbc	hl,de
	pop	hl
	jr	z,nnhs
	jr	nc,nhs
nnhs:	ex	de,hl
	inc	a
nhs:	or	a
	ret

SdispHL:
 		ld (_penCol),de			
		ld de,-1				;routine by Matthew Scepcar
		ld (_curRow),de
		xor a
		call $4a33
		dec hl
		jp _vputs

_clrbuf:
        ld hl,$ca06
        ld de,$ca07
        ld bc,1023
        ld (hl),0
        ldir
        ret

DispText:
 ld (_penCol), de
 call _vputs
 ret
varname:
.db 8,"RobotWar"


gameover:   .db "| Game Over |",0
HighScr:	.db "High "
scoretxt:	.db "Score: ",0
NHSMsg:		.db "New High Score!",0
Blank:      .db "                     ",0
timetxt:    .db "Time:",0
robot:      .db "Robot",0
wars:       .db "Wars",0


 ret 

MoveLeft:
 ld a,(x)
 cp 1
 jp z, MainLoop
 call LoadPlayer
 ld a,(x)
 dec a
 ld (x),a
 call LoadPlayer
 jp TestIntercept
MoveRight:
 ld a,(x)
 cp 90
 jp z, MainLoop
 call LoadPlayer
 ld a,(x)
 inc a
 ld (x),a
 call LoadPlayer      
 jp TestIntercept
MoveUp:
 ld a,(y)
 cp 1
 jp z, MainLoop
 call LoadPlayer
 ld a,(y)
 dec a
 ld (y),a
 call LoadPlayer
 jp TestIntercept
MoveDown:
 ld a,(y)
 cp 55
 jp z, MainLoop
 call LoadPlayer
 ld a,(y)
 inc a
 ld (y),a
 call LoadPlayer
 jp TestIntercept
LoadPlayer:
 ld a,(x)      ;load x variable into a
 ld b,a         ;. 
 ld a,(y)      ;load x variable into a
 ld c,a         ;. 
 ld hl,PIC1     ;. 
 call PutSprite ;Put Pic1 at (c,b)
 ret
LoadGopher:
 ld a,(gx)      ;load x variable into a
 ld b,a         ;. 
 ld a,(gy)      ;load x variable into a
 ld c,a         ;. 
 ld hl,PIC2     ;. 
 call PutSprite ;Put Pic1 at (c,b)
 ret
TestIntercept:
 call LoadGopher
 call moveenemy
 call LoadGopher

 ld a,(gx)
 sub 8
 ld c,a
 ld a,(x)
 cp c
 jp p,ContIntercept
 ld b,a
 xor a
 sub b
ContIntercept:
 jp p, cont2
 jp MainLoop
cont2:
 ld a,(gx)
 add a,8
 ld c,a
 ld a,(x)
 cp c
 jp p,MainLoop

 ld a,(gy)
 sub 8
 ld c,a
 ld a,(y)
 cp c
 jp p,ContIntercept2
 ld b,a
 xor a
 sub b
ContIntercept2:
 jp p, cont3
 jp MainLoop
cont3:
 ld a,(gy)
 add a,8
 ld c,a
 ld a,(y)
 cp c
 jp p,MainLoop

 ld hl,(score)
 inc hl
 ld (score),hl
 call UpdateScore
 call LoadGopher 
 ld a,90
 call random
 inc a
 ld (gx),a
 ld a,55
 call random
 inc a
 ld (gy),a
 call LoadGopher
 jp MainLoop

moveenemy:
 ld a,4
 call random
 inc a
 cp 1
 jp z,g1
 cp 2
 jp z,g2
 cp 3
 jp z,g3
 cp 4
 jp z,g4
g1:
 ld a,(gy)
 cp 1
 jp z,moveenemy
 dec a
 ld (gy),a
 jp ext2
g3:
 ld a,(gy)
 cp 55
 jp z,moveenemy
 inc a
 ld (gy),a
 jp ext2
g2:
 ld a,(gx)
 cp 90
 jp z,moveenemy
 inc a
 ld (gx),a
 jp ext2
g4:
 ld a,(gx)
 cp 1
 jp z,moveenemy
 dec a
 ld (gx),a
 jp ext2
ext2:
 ret


pause:
    call GET_KEY             ;gets the recent key pressed
    cp K_EXIT                ;compare it to exit
    jr z,exitpause         ;if it's exit, go to TimetoLeave
    cp K_SECOND               ;and similar
    jp z,exitpause
    cp K_ENTER               ;and similar
    jp z,exitpause
    jp pause
exitpause:
    ret
random: 	       ; Creates a random number 0 <= x < A
 	push bc
 	push de
 	push hl
 	ld b,a
 	ld a,r
 	add a,a
 	ld hl,0
 	ld d,0
 	ld e,a
RMul:
 	add hl,de
 	djnz RMul
 	ld a,h
 	pop hl
 	pop de
 	pop bc
 	ret
UpdateScore:                
  ld de,2662h
  ld hl,(score)
  call SdispHL             
    ret
;    ld hl,$386B             ;this is the cursor place
;    ld (_penCol),hl         ;and put it in
;    ld hl,(score)           ;now we get score
;    ld de,StringPlace+4     ;start of unpacking
;    ld b,5                  ;5 digits
;UpdateScore2:
;    call UNPACK_HL          ;divide hl by 10 and a contains remainder
;    add a,'0'               ;asciiize it
;    ld (de),a               ;put it in
;    dec de                  ;next digit place to load
;    djnz UpdateScore2       ;keep going
;    ld hl,StringPlace       ;now we put it back
;    call _vputs             ;and display the score
    ret

UpdateTime: 
    ld a,(timer5)
    inc a
    ld (timer5),a
    cp 200
    jp nz,rret     

 ld hl,(time)
 dec hl
 ld (time),hl   
       
 ld de, 1664h
 ld hl,Blank
 call DispText

  ld de,1662h
  ld hl,(time)
  call SdispHL
 
 
 ld a,0000h
 ld hl,(time)
 cp (hl)
 jp z,ext
 jp rret

ext:
 ld a,160
 ld c,a
 ret 
rret:
    ret


StringPlace:
.db 0,0,0,0,0,0

time:
  .dw $C8
High:
    .db $01

PIC1: 
.db %10011001 
.db %11111111 
.db %00111100 
.db %00011000 
.db %00100100 
.db %01100110 
.db %01100110 
.db %11000011 

PIC2: 
.db %10011001 
.db %11111111 
.db %10111101 
.db %10011001 
.db %10100101 
.db %01100110 
.db %01100110 
.db %11011011

TitleScreen:   ;Use Pic2rle!
 .db $91,$00,$23,$ff,$fc,$00,$00,$1f,$80,$91,$00,$0a
 .db $ff,$ff,$00,$00,$0f,$80,$91,$00,$0a,$ff,$ff,$80
 .db $00,$0f,$80,$00,$00,$01,$e0,$91,$00,$06,$ff,$ff
 .db $80,$00,$0f,$80,$00,$00,$01,$e0,$91,$00,$06,$fc
 .db $1f,$80,$00,$0f,$80,$00,$00,$03,$e0,$91,$00,$06
 .db $fc,$1f,$80,$00,$0f,$80,$00,$00,$03,$e0,$91,$00
 .db $06,$fc,$1f,$81,$f8,$0f,$fe,$00,$fc,$1f,$fe,$91
 .db $00,$06,$ff,$ff,$07,$fe,$0f,$ff,$83,$ff,$1f,$fe
 .db $91,$00,$06,$ff,$fc,$0f,$ff,$0f,$ff,$87,$ff,$9f
 .db $fe,$91,$00,$06,$ff,$fe,$1f,$9f,$0f,$07,$cf,$cf
 .db $87,$c0,$91,$00,$06,$ff,$ff,$1f,$8f,$8f,$07,$cf
 .db $c7,$c7,$c0,$91,$00,$06,$f8,$3f,$9f,$0f,$8f,$07
 .db $cf,$87,$c7,$c0,$91,$00,$06,$f8,$3f,$9f,$0f,$8f
 .db $07,$cf,$87,$c7,$c0,$91,$00,$06,$f8,$3f,$9f,$0f
 .db $8f,$07,$cf,$87,$c7,$c0,$91,$00,$06,$f8,$3f,$9f
 .db $0f,$8f,$07,$cf,$87,$c7,$ce,$91,$00,$03,$01,$32
 .db $00,$f8,$3f,$8f,$0f,$8f,$07,$87,$87,$c7,$ce,$01
 .db $32,$00,$01,$fe,$00,$f8,$3f,$8f,$ff,$0f,$ff,$87
 .db $ff,$87,$fe,$01,$fe,$00,$00,$78,$00,$f8,$3f,$87
 .db $fe,$0f,$ff,$03,$ff,$03,$fc,$01,$7a,$00,$00,$30
 .db $00,$00,$0f,$81,$f8,$0f,$fc,$00,$fc,$01,$f8,$01
 .db $32,$00,$00,$48,$91,$00,$0b,$01,$4a,$00,$00,$cc
 .db $91,$00,$0c,$cc,$00,$00,$cc,$91,$00,$0c,$cc,$00
 .db $01,$86,$00,$1f,$87,$f1,$f0,$91,$00,$06,$01,$86
 .db $91,$00,$04,$1f,$87,$f1,$f0,$91,$00,$0c,$1f,$8f
 .db $f3,$f0,$91,$00,$0c,$0f,$cf,$f3,$e0,$91,$00,$0c
 .db $0f,$cf,$f3,$e0,$91,$00,$0c,$0f,$cf,$f3,$e0,$91
 .db $00,$0c,$0f,$df,$f3,$e0,$7f,$03,$ff,$03,$fc,$91
 .db $00,$07,$0f,$df,$fb,$e1,$ff,$c3,$ff,$87,$fe,$91
 .db $00,$07,$07,$df,$ff,$c3,$ff,$e3,$ff,$cf,$ff,$91
 .db $00,$07,$07,$fe,$ff,$c3,$e3,$e3,$e7,$cf,$9f,$91
 .db $00,$07,$07,$fe,$ff,$c0,$03,$e3,$e7,$cf,$80,$91
 .db $00,$07,$07,$fe,$ff,$c0,$3f,$e3,$e7,$cf,$fe,$91
 .db $00,$07,$07,$fe,$ff,$c3,$ff,$e3,$e0,$07,$ff,$91
 .db $00,$07,$03,$fc,$ff,$83,$e7,$e3,$e0,$03,$ff,$80
 .db $91,$00,$06,$03,$fc,$7f,$87,$c7,$e3,$e0,$00,$0f
 .db $80,$91,$00,$06,$03,$fc,$7f,$87,$c7,$e3,$e0,$0f
 .db $8f,$80,$91,$00,$06,$03,$fc,$7f,$87,$ff,$e3,$e0
 .db $0f,$ff,$80,$91,$00,$06,$03,$f8,$7f,$07,$ff,$e1
 .db $e0,$07,$ff,$91,$00,$0a,$01,$fb,$e0,$00,$01,$fc
 .db $91,$00,$5f,$1c,$91,$00,$05,$ff,$00,$00,$f8,$f0
 .db $91,$00,$03,$ff,$c0,$1c,$e0,$91,$00,$04,$ff,$80
 .db $00,$fd,$f0,$01,$83,$00,$ff,$c0,$1c,$e0,$91,$00
 .db $04,$e7,$80,$00,$fd,$f0,$01,$83,$00,$ff,$c0,$00
 .db $e0,$91,$00,$04,$e7,$bd,$c0,$fd,$f7,$e7,$ff,$e0
 .db $1e,$1e,$1c,$e7,$bc,$3f,$80,$00,$ff,$1d,$c0,$fd
 .db $ff,$f7,$ff,$e0,$1e,$3f,$1c,$fe,$7e,$3f,$c0,$00
 .db $ff,$9f,$80,$ff,$f0,$73,$87,$00,$1e,$7b,$9c,$fe
 .db $f7,$39,$c0,$00,$f3,$df,$80,$ff,$f7,$f3,$87,$00
 .db $1e,$7f,$9c,$fe,$ff,$39,$c0,$00,$f3,$cf,$80,$ff
 .db $fe,$f3,$87,$00,$1e,$70,$1c,$ef,$e0,$39,$c0,$00
 .db $ff,$cf,$00,$ef,$7f,$f3,$f7,$e0,$1e,$3f,$9c,$ef
 .db $7f,$39,$c0,$00,$ff,$87,$00,$ef,$7f,$f1,$f3,$e0
 .db $1e,$1f,$1c,$e7,$be,$39,$c0,$00,$00,$3f,$91,$00
 .db $0f,$3e,$91,$00,$0f,$1e,$91,$00,$2d

DispRLE:
 ld bc,1024			; we need to copy 
DispRLEL:
 ld a,(hl)			; get the next byte
 cp $91				; is it a run?
 jr z,DispRLERun	; then we need to decode the run
 ldi				; copy the byte, and update counters
DispRLEC:
 ld a,b				; check the low byte and
 or c				; the high byte for 0
 jr nz,DispRLEL		; if not, then we're not done either
 ret				; if it's zero, we're done
DispRLERun:
 inc hl				; move to the run value
 ld a,(hl)			; get the run value
 inc hl				; move to the run count
 push hl			; save source pointer
 ld h,(hl)			; get the run count
 ex de,hl			; swap source and destination pointers
DispRLERunL:
 ld (hl),a			; copy the byte
 inc hl				; increase destination pointer
 dec bc				; decrease byte count
 dec d				; decrease run count
 jr nz,DispRLERunL	; if we're not done, then loop
 ex de,hl			; swap pointers back
 pop hl				; recover source pointer
 inc hl				; advance the source pointer
 jr DispRLEC		; check to see if we should loop


PutSprite: 
;FastSprite_______________________________
;Input: Sprite in (HL), (b,c)            |
;Output: Sprite xor'ed onto the screen   |
;Destroyed: none                         |
;-----------------------------------------
	push af
	push bc
	push de
	push ix
	push hl
	push hl                 ;\
	pop ix                  ; > hl -> ix
	ld hl, FSByte           ;> point to Tempbyte
	ld (hl), c              ;> put c into Byte for later use
	ld a, b
	rrca                    ;\
	rrca                    ; > divide x by 8 in accumulator
	rrca                    ;/                      
	rld                     ;> Rotate left 4 bytes  
	or $FC                  ;> add a and $FC
	ld l, (hl)              ;\
	ld h, a                 ; > buncha loading going on
	ld a, b                 ;/
	and 7                   ;> mask out the shift number
	ld d, a                 ;> save the shift number
	ld e, 8
FSLoop:                         
	ld a, (ix)              ;> get sprite data
	ld b, a
	inc ix                  ;> point to new sprite data byte
	ld c, 0                 ;> clear c for shift use
	ld a, d                 ;> restore shift # for use
	cp 0
	jp z, NoShift
	ld a, b
	ld b, d
FSShift:
	srl a                   ;\
	rr c                    ; \
	dec b                   ;  > shift until b < 0
	jp z, Shiftend          ; /
	jp FSShift              ;/
NoShift:
	ld a, b
Shiftend:
	xor (hl)                ;> mix the shifted sprite w/screen
	ld (hl), a              ;> and draw it to the screen
	inc hl                  ;> hl points to next screen byte
	ld a, c                 ;> accumulate the remaining shifted data
	xor (hl)                ;> mix 'em
	ld (hl), a              ;> draw it
	ld a, 15                ;\
	add a, l                ; \
	ld l, a                 ;  > Inc the <HL> 1 y value.
	jp nc, FSNoinc          ; /
	inc h                   ;/
FSNoinc:
	dec e                   ; >check if loop is finished
	jp nz, FSLoop           ;/
	pop hl                  ;\
	pop ix                  ; \
	pop de                  ;  > mmmpop boop be doop mmmpop
	pop bc                  ; /  
	pop af                  ;/
	ret
FSByte: 
        .db $00
